// norpricesupport.js V4.03 ECB 
var havealtprice = false;
var choicealtprice = false;
var onlyscanonce = false;
// if favourite currency set then get it
var allcookies = document.cookie;
var pos = allcookies.indexOf('destcurr=');
var isoname = '';
if ( pos != -1 )
	{
	var start = pos + 9;
	var end = allcookies.indexOf(';', start);
	if ( end == -1 ) end = allcookies.length;
	var value = unescape(allcookies.substring(start,end));
	var bits = value.split(':');
	isoname = bits[0];
	var base = bits[1];
	var dest = bits[2];
	var exchange = base / dest;
	var cgibase = cgiurl.replace(/(.*:\/\/)?(.*\/).*/, "$2");
	if ( (isoname != hidemain) && (isoname != hidealt) && (dest > 0) 
		&& (location.href.indexOf(cgibase + 'bb') == -1) 
		&& (location.href.indexOf(cgibase + 'ca') == -1) ) havealtprice = true;
	if ( (isoname != hidemain) && (isoname != hidealt) && (dest > 0) ) choicealtprice = true;
	}

function norpricereload(){
	var loc = document.location.href;
	if ( loc.match(/\/ca\d{6}\.(pl|cgi)$/) )			// if just Added to Cart
		{
		document.location = loc + '?ACTION=SHOWCART';		// don't refresh as this will add more stock
		}
	else
		{
		document.location.reload();
		}
}

function fb_show(link, height, width){
	$.fancybox({type:'iframe', href:link, width:width, height:height, onClosed:norpricereload});
}

function norpricepopup(){		// a currency link has been clicked
	var arg = '';
	if ( arguments.length == 1 ) return silentlysetcurrency(arguments[0]);			// single currency requested
	fb_show(prevloc + 'norpricepopup' + '.html?' + arg + 'hidemain=' + hidemain + '&showonly=' + showonly + '&nplink=' + nplink, 180, 470);
}	

function CommaFormatted(num){		// comma every 3 places
	var sep = ',';
	num = num.toString().split('').reverse().join('');					// reverse number
	num = num.replace(/(\d\d\d)(?=\d)(?!\d*\.)/g,'$1' + sep);				// add commas
	return num.split('').reverse().join('');						// reverse number back;
}

function showalt(price){ 		// show a formatted price
	if ( havealtprice )
		{
		document.write(getalt(price, true)); // display formatted price
		}  
}

function getalt(price, formatted){	// return converted price with optional HTML formatting
	var prefix = formatted ? '<span class="altprice">' : '';  				// see if we want HTML formatting
	var suffix = formatted ? '</span>' : '';                  				//    or just plain text
	var optplus = price.match(/\+/) ? '+' : '';						// remember if leading "+"
	price = price.replace(/&#44;|,/g,"");							// remove all commas
	price = price.replace(/&#46;/g,".");    						// restore decimal point
	var pbits = price.match(/(-?\d+\.\d\d)/);						// now look for first [-]n.nn 
	if ( pbits != null )
		{ 
		var numprice = pbits[1];
		var altprice = numprice * exchange;
		// remove comment below to show non EU currencies ex-VAT
		//   if ( 'EUR-DKK-SEK-GBP'.indexOf(isoname) == -1 ) altprice = altprice / 1.2;
		if ( exchange > hidefraction )
			{
			return prefix + ' (' + optplus + CommaFormatted(Math.round(altprice)) + ' ' + isoname + ')' + suffix;
			}
		else
			{
			return prefix + ' (' + optplus + CommaFormatted(altprice.toFixed(2)) + ' ' + isoname + ')' + suffix;
			}
		}
	return ' --- ';  // should never get here but just in case...
}

// now code to deal with prices embedded in choice description
var selcode;

if ( mainsymbol == '$' ) mainsymbol = '\\' + mainsymbol;					// escape dollar
var pattern = new RegExp('(.*)(' + mainsymbol + ')([\\d,]+\\.\\d\\d)(.*)');			// match for e.g. 12.34 or 1,234.56
function cnvtext(text, formatted){
	if ( ! choicealtprice ) return text;							// no conversion needed
	//
	// this routine could be changed to allow for different ways of including the option price.
	//
	text = text.replace(/&#(\d+);/g, function(m,s){return String.fromCharCode(s - 0)});	// remove Actinic escaping
	val = text.match(pattern);								// have we currency symbol then n.nn
	if ( val != null )
		{
		var sign = ''
		var spos = val[1].match(/([-\+])$/);						// see if there was a + or -
		if ( spos != null ) sign = spos[1];
		var thisval = sign + val[3].replace(/,/g,'');					// create the optionally signed value
		if ( isNaN(thisval) ) return text;						// ignore invalid numbers
		return val[1] + val[2] + val[3] + getalt(thisval, formatted) + val[4];		// return potentially converted text
		}
return text;					// return unaltered text
}

// V2 jQuery method
function pricelabels(){
	if ( onlyscanonce ) return;
	onlyscanonce = true;
	if ( ! choicealtprice ) return;
	$("span[class='NorPrice']").each(function(index) { $(this).html(cnvtext($(this).html(), true)) }); // normal inline prices
	$("option[class='NorPrice']").each(function(index) { this.text = cnvtext(this.text, false) });	   // option tags
}

// Redefine SD 2013 dynamic pricing to include NorPrice
function FormatPrices(nPrice){
	var arrPrices = [];
	for (var i = 0; i < g_oConfig.arrCurrs.length; i++)
		{
		var oCurr = g_oConfig.arrCurrs[i];
		arrPrices.push(FormatPrice(nPrice, oCurr));
		}
	if (arrPrices.length == 1)
		{
		return cnvtext(arrPrices[0], true);
		}
	else
		{ 
		return Sprintf(g_oConfig.sPriceFmt, cnvtext(arrPrices[0], true), arrPrices[1]);
		} 
}

$(document).ready(function() { 		// do convert on page reload
	pricelabels(); 
});

// new code for setting rate without popup
function setcookieandreload(newcurr){
	if ( ecodes[newcurr] )
		{
		document.cookie = "destcurr=" + escape(newcurr + ':' + ecodes[newcurr].rate + ':' + ecodes[hidemain].rate) + '; path=/';
		norpricereload();
		return;
		}
	alert('Unknown currency ' + newcurr);	
}

function silentlysetcurrency(newcurr){		// load a preselected currency without a popup
	jQuery.ajax({
		async:		false,
		type:		'GET',
		url:		nplink + "norpricejs.php",
		data:		null,
		success:	function(){setcookieandreload(newcurr);},
		dataType:	'script'
	    });
}

function npinlinedropdown(sel){		// called from inline drop-down list
	var val = sel.options[sel.selectedIndex].value;
	if( val != '' ) silentlysetcurrency(val);
}

function generateecboptionnames(){		// generate option set of currency names
	var optcode = '';
	for ( var currency in ecodes )
		{
		var ecode = ecodes[currency].code;
		if ( (showonly == '') || (showonly.indexOf(ecode) > -1) )
			{
			optcode += '<option class="npinlinedd"';
			if ( ecode == isoname ) optcode += ' selected';
			optcode += ' value="' + ecode + '">';
			optcode += ecode + ' ' + ecodes[currency].lname;
			optcode += '</option>';
			}
		}
	document.write(optcode);
}

// deal with Fancybox window closing
$(window).on("message", function(e) 
		{
		if (e.originalEvent.data == 'fancy_close') $.fancybox.close();
		}
	);
	
// END norpricesupport.js